#!/usr/bin/python

import os, sys, socket, time

sys.path.append(".")
from hostfunctions import *

# 2001:700:300:10a3/64
masters = ["0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa", 
   "3.a.0.1.0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa", "v6.ntnu.no"]

global serial
serial = int(time.time())

def soatext():
    text = "ns-v4.hyse.org. hostmaster.ntnu.no. xxxx 10800 3600 604800 3600"
    global serial
    serial  = serial + 1
    return text.replace("xxxx", str(serial))

global pdns_id_counter, pdns_id

# ids used when sending to pdns .. 
pdns_id = {99: 'foo', '98':'bar'}
pdns_id_counter = 1


def send(s):
    sys.stdout.write("%s\n" %s )
    sys.stdout.flush()
    log("send() sent: %s" %s)

def log(s):
    sys.stderr.write("[%i] %s\n" % (os.getpid(),s))
    sys.stderr.flush()
    return


def queryhandler(q):
    pass


def axfrhandler(q):
    return []

def rr2data(qname, qtype, content):
    global pdns_id_counter, pdns_id
    id = pdns_id_counter 
    pdns_id_counter += 1
    pdns_id[id] = qname
    s  = "DATA\t%s\t" % qname
    s += "IN\t%s\t60\t%i\t" % (qtype, id)
    s += content
    return s

if __name__ == "__main__":

    

    output = sys.stdout

    log("starter opp ..")
    d = sys.stdin.readline()
    d = d.strip().split("\t")

#    log( "d = %s" % d)
    if (d == ['HELO', '1']):
        send("OK\t PDNS IPv6 backend")
    else:
        send("FAIL")
        log("strange greeting: %s" % d)
        log("further it says: %s" % (sys.stdin.readline().strip().split("\t")))
        time.sleep(10)

#    log("entering eventloop")

    while 1:
        d = sys.stdin.readline().strip()

        z = d.split('\t')
    #    log("read: %s" % d)
        log("z er: %s" % z)

        if z[0] == "PING":
            send("END")
            continue

        # [24611] z er: ['Q', 'www.digi.no', 'IN', 'ANY', '-1', '127.0.0.1']
        #[26727] z er: ['Q', '1.c.e.b.1.f.1.8.0.0.0.0.0.0.0.0.1.0.0.0.0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa', 'IN', 'SOA', '-1', '127.0.0.1']

        if (z[0] == "AXFR"):
            # qclass is the wrongly named variable for id on axfrs.
            id = int(z[1].strip())
            if not (pdns_id.has_key(id)):
                log("has no such key: %s" % id)
                log("my list is: %s" % pdns_id)
                log("my keys are: %s" % pdns_id.keys())
                send("FAIL")
                continue
            zone = pdns_id.get(id)

            if zone in masters:
                # send ns/soa
                send(rr2data(zone, "NS", "ns-v4.hyse.org."))
                send(rr2data(zone, "SOA", soatext()))
                send("END\t")
                continue
            else:
                send("END\t")
                continue



        handle_query = 0
        # see if we're master for this sone.
        for zone in masters:
            if ((z[0] == 'Q') and z[1].find(zone) > -1):
                handle_query = 1
                masterzone = zone
#                log("this query is a part of the %s zone" % zone);

        if not handle_query:
            log("not authorative, ignoring query")
            send("END\t")
            continue

        #  ['Q', 'www.digi.no',                                                              'IN', 'ANY', '-1', '127.0.0.1']
        #  ['Q', '1.c.e.b.1.f.1.8.0.0.0.0.0.0.0.0.1.0.0.0.0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa', 'IN', 'SOA', '-1', '127.0.0.1']

        ##############################################
        (type, qname, qclass, qtype, id, ip) = z
        ##############################################



        if (qtype == "ANY" and qname == masterzone):
            send(rr2data(masterzone, 'NS', 'ns-v4.hyse.org.'))
            send(rr2data(masterzone, 'SOA', soatext()))
            send("END\t")
            continue
#            qtype = "SOA"


        if (qtype == "NS" and (qname.find(masterzone) > -1)):
            send(rr2data(masterzone, 'NS', 'ns-v4.hyse.org.'))
            # kaster med soa, for good measure
            send(rr2data(masterzone, 'SOA', soatext()))
            send("END\t")
            continue

        if (qtype == "SOA" and (qname.find(masterzone) > -1)):
            send(rr2data(masterzone, 'SOA', soatext()))
            send("END\t")
            continue

        # [27694] send() sent: DATA 1.c.e.b.1.f.1.8.0.0.0.0.0.0.0.0.1.0.0.0.0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa IN      PTR      60     -1      foo.dyn.ntnu.no
        # qt = ['Q', 'www.digi.no', 'IN', 'ANY', '-1', '127.0.0.1']
        #[26727] z er: ['Q', '1.c.e.b.1.f.1.8.0.0.0.0.0.0.0.0.1.0.0.0.0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa', 'IN', 'SOA', '-1', '127.0.0.1']

        # svar:
        # Q           ds9a.nl         IN      SOA     -1      213.244.168.210
        # DATA        ds9a.nl         IN      SOA     86400   1 ahu.ds9a.nl ...

        if ((qtype == "ANY" or qtype == "AAAA") and (masterzone.find("ip6.arpa") > -1)):
            f = reverse2ip(qname)
            s = rr2data(qname, "PTR", ip2host(f, "v6.ntnu.no"))
            send(s)
            send("END\t")
            continue

        # FINNER REVERS BASERT PAA HOSTNAVN
        if (qtype == "ANY" and qname != masterzone and (masterzone.find("v6.ntnu.no") > -1)):
            log("qname: %s" % qname)
            s = rr2data(qname, "AAAA", host2ip(qname))
            send(s)
            send("END\t")
            continue

        send("LOG\treached bottom")
        send("END\t")

    log("shouldnt happend")
